/*****************************************************************************
**
** program_ugnx3_faseted_model_from_a_solid_body.cpp
**
** Description:
**     Contains Unigraphics entry points for the application.
**

   <solid_body>    <facet_model>
c   <facet_model>   
     <facet_str>
   <solid_body>,    <facet_model>
       <new_model> 


 13  2006   17,00   ..



*****************************************************************************/

/* Include files */
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#   include <strstream>
#   include <iostream>
    using std::ostrstream;
    using std::endl;    
    using std::ends;
    using std::cerr;
#else
#   include <strstream.h>
#   include <iostream.h>
#endif





#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_ui.h>
#include <uf_ui_types.h>
#include <uf_exit.h>
#include <uf_disp.h>
#include <uf_obj.h>
#include <uf_ui_types.h>
#include <uf_object_types.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_vec.h>
#include <uf_mtx.h>
#include <uf_csys.h>
#include <uf_attr.h>
#include <uf_curve.h>
#include <uf_modl.h>
#include <uf_view.h>
#include <uf_group.h>
#include <uf_gexp.h>
#include <uf_drf.h>
#include <uf_attr.h>
#include <uf_facet.h>





#define PRTERR if(errorCode)\
					{\
						PrintErrorMessage(errorCode,__LINE__);\
						errorCode=0;\
						goto term;\
					}



static	FILE*		prterr;
static	int			errorCode;




static	void	PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"errorCode=%d		message=%s		line=%d\n",
			errorCode,message,line);
		fflush(prterr);
	}
}


//UF_UI_SEL_FEATURE_SOLID_BODY -     -  
static	int	solid_init_proc(UF_UI_selection_p_t	select, void*	user_data)
{
	int				ret_code;
	int				num_triples=1;
	
	UF_UI_mask_t	mask_triples[]={UF_solid_type,0,UF_UI_SEL_FEATURE_SOLID_BODY};

	ret_code=UF_UI_set_sel_mask
		(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples,mask_triples);

	
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;
	else
		return UF_UI_SEL_FAILURE;

}


static	int	do_it(void)
{

	tag_t	solid_body;

	//  
get_solid:
	{
		char*	message="  ";
		char*	title="  ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int		response;
		tag_t	object;
		double	cursor[3];
		tag_t	view;

		errorCode=UF_UI_select_with_single_dialog
			(message,title,scope,solid_init_proc,NULL,&response,&object,cursor,&view);
		PRTERR;

		switch(response)
		{
		case UF_UI_BACK:
			goto get_solid;
		case UF_UI_CANCEL:
			goto term;
		}

		if(object==NULL_TAG)
			goto get_solid;

		solid_body=object;

		errorCode=UF_DISP_set_highlight(object,0);PRTERR;

	}




	tag_t	facet_model;

	//  
	{
		
		UF_FACET_parameters_t	parameters;

		parameters.version=-2;
		parameters.max_facet_edges=3;

		parameters.specify_surface_tolerance=TRUE;
		parameters.surface_dist_tolerance=1.0;
		parameters.surface_angular_tolerance=1.0;

		parameters.specify_curve_tolerance=TRUE;
		parameters.curve_dist_tolerance=1.0;
		parameters.curve_angular_tolerance=1.0;
		parameters.curve_max_length=100000.0;

	
		parameters.specify_convex_facets=TRUE;

		parameters.specify_max_facet_size=TRUE;
		parameters.max_facet_size=10.0;

		parameters.number_storage_type=UF_FACET_TYPE_DOUBLE;

		parameters.specify_parameters=FALSE;

		parameters.specify_view_direction=FALSE;

		parameters.store_face_tags=FALSE;

		
		errorCode=UF_FACET_facet_solid(solid_body,
			//NULL,//  
			&parameters,
			&facet_model);PRTERR;
		
		

		errorCode=UF_FACET_disassoc_from_solid(facet_model);PRTERR;
		
		
	}

	uc1601("enjoy facets",1);




	int	facet_array[10000];
	int	facet_count=0;

	//  
	{
		int	facet_id;

		facet_id=UF_FACET_NULL_FACET_ID;

		errorCode=UF_FACET_cycle_facets(facet_model,&facet_id);PRTERR;

		if(facet_id != UF_FACET_NULL_FACET_ID)
		{
			facet_array[facet_count]=facet_id;
			facet_count++;
		}

		while(facet_id != UF_FACET_NULL_FACET_ID)
		{
			fprintf(prterr,"facet_id=%d\n",facet_id);

			errorCode=UF_FACET_cycle_facets(facet_model,&facet_id);PRTERR;

			if(facet_id != UF_FACET_NULL_FACET_ID)
			{
				facet_array[facet_count]=facet_id;
				facet_count++;
			}

		}

	}



	struct FACET
	{
		int		facet_id;
		double	vertices[3][3];
		double	normals[3][3];
		int		adj_fcet_id1;
		int		adj_fcet_id2;
		int		adj_fcet_id3;
		int		use_flag;
		int		new_facet_id;

	}facet_str[1000];

	//    
	{
		int					i,j;
		int					num_vertices;
		double				vertices[3][3];
		double				normals[3][3];
		int					edge_id;
		int					adjacent_facet_id;
		int					edge_id_in_adjacent_facet;

		//UF_CURVE_line_t		line;
		//tag_t				line_tag;

		for(i=0;i<facet_count;i++)
		{
			// 
			facet_str[i].facet_id=facet_array[i];
			facet_str[i].use_flag=0;

			// 
			errorCode=UF_FACET_ask_vertices_of_facet
				(facet_model,facet_array[i],&num_vertices,vertices);
			PRTERR;

			for(j=0;j<3;j++)
				UF_VEC3_copy(vertices[j],facet_str[i].vertices[j]);
			
			// 
			errorCode=UF_FACET_ask_normals_of_facet
				(facet_model,facet_array[i],&num_vertices,normals);
			PRTERR;
			
			for(j=0;j<3;j++)
				UF_VEC3_copy(normals[j],facet_str[i].normals[j]);
			
			

			for(edge_id=0;edge_id<3;edge_id++)
			{
				errorCode=UF_FACET_ask_adjacent_facet
					(facet_model,facet_array[i],edge_id,&adjacent_facet_id,&edge_id_in_adjacent_facet);
					PRTERR;
				if(edge_id==0)
					facet_str[i].adj_fcet_id1=adjacent_facet_id;
				
				if(edge_id==1)
					facet_str[i].adj_fcet_id2=adjacent_facet_id;

				if(edge_id==2)
					facet_str[i].adj_fcet_id3=adjacent_facet_id;

			}


		

		}

	}




	//     
	{
		errorCode=UF_OBJ_delete_object(solid_body);PRTERR;
		errorCode=UF_OBJ_delete_object(facet_model);PRTERR;

	}


	tag_t	new_model;

	//    
	{
		
		tag_t	disp_part;
		int		i,j;
		double	facet_vertices[3][3];
		double	facet_normals[3][3];
		int		adj_facet1;
		int		adj_facet2;
		int		adj_facet3;
		int		adjacencies[3];
		int		facets[10000];

		disp_part=UF_PART_ask_display_part();
		if(disp_part==NULL_TAG)
		{
			uc1601("there is not display part",1);
			fprintf(prterr,"there is not display part	line=%d\n",__LINE__);
		}

		errorCode=UF_FACET_create_model(disp_part,&new_model);PRTERR;
		
		for(i=0;i<facet_count;i++)
		{
			// 
			for(j=0;j<3;j++)
				UF_VEC3_copy(facet_str[i].vertices[j],facet_vertices[j]);

			// 
			for(j=0;j<3;j++)
				UF_VEC3_copy(facet_str[i].normals[j],facet_normals[j]);

			// 1
			adj_facet1=facet_str[i].adj_fcet_id1;
			if(facet_str[adj_facet1].use_flag==1)
				adjacencies[0]=facet_str[adj_facet1].new_facet_id;
			else
				adjacencies[0]=UF_FACET_NULL_FACET_ID;

			// 2
			adj_facet2=facet_str[i].adj_fcet_id2;
			if(facet_str[adj_facet2].use_flag==1)
				adjacencies[1]=facet_str[adj_facet2].new_facet_id;
			else
				adjacencies[1]=UF_FACET_NULL_FACET_ID;

			// 3
			adj_facet3=facet_str[i].adj_fcet_id3;
			if(facet_str[adj_facet3].use_flag==1)
				adjacencies[2]=facet_str[adj_facet3].new_facet_id;
			else
				adjacencies[2]=UF_FACET_NULL_FACET_ID;

			errorCode=UF_FACET_add_facet_to_model
				(new_model,3,facet_vertices,
				//NULL,
				facet_normals,
				adjacencies,facets+i);
			PRTERR;

			facet_str[i].use_flag=1;
			facet_str[i].new_facet_id=facets[i];


		}

		tag_t	view_tag;
		char*	view_name="TFR-TRI";

		errorCode=UF_VIEW_ask_tag_of_view_name(view_name,&view_tag);PRTERR;

		errorCode=UF_VIEW_fit_view(view_tag,0.8);PRTERR;

		errorCode=UF_VIEW_update_view(view_tag);PRTERR;

		errorCode=UF_DISP_regenerate_view(view_tag);PRTERR;
	}

	
	uc1601("enjoy facet",1);


	//   <point_array>   
	//     <triple_array>
	//     
	
	double	point_array[5000][3];
	int		triple_array[5000][3];
	int		point_count=0;
	

	{//     

		
		int		i,j,k;
		int		is_equal;
		double	test_point[3];

		UF_VEC3_copy(facet_str[0].vertices[0],point_array[0]);
		triple_array[0][0]=point_count;
		point_count++;
		
		UF_VEC3_copy(facet_str[0].vertices[1],point_array[1]);
		triple_array[0][1]=point_count;
		point_count++;

		UF_VEC3_copy(facet_str[0].vertices[0],point_array[2]);
		triple_array[0][2]=point_count;
		point_count++;

		for(i=1;i<facet_count;i++)//  
		{

			for(j=0;j<3;j++)//   
			{
				UF_VEC3_copy(facet_str[i].vertices[j],test_point);
				for(k=0;k<point_count;k++)//  
				{
					UF_VEC3_is_equal(test_point,point_array[k],0.005,&is_equal);
					if(is_equal)
					{
						triple_array[i][j]=k;
						break;
					}
						
				}//for(k=
			
				if(!is_equal)
				{
					UF_VEC3_copy(test_point,point_array[point_count]);
					triple_array[i][j]=point_count;
					point_count++;
				}

			}//for(j=

		}//for(i=

	}//     






	//  
	{
		int	i;

		for(i=0;i<point_count;i++)
			fprintf(prterr,"point_count=%d	%5.5d	%5.5d	%5.5d	\n",
			i,triple_array[i][0],triple_array[i][1],triple_array[i][2]);	

	}

	


	// default faceting parameters
	{

		UF_FACET_parameters_t	parameters;

		errorCode=UF_FACET_ask_default_parameters(&parameters);PRTERR;
		
		fprintf(prterr,"\n");
		fprintf(prterr,"parameters.version				%d\n",parameters.version);
		fprintf(prterr,"parameters.max_facet_edges		%d\n\n",parameters.max_facet_edges);

		fprintf(prterr,"parameters.specify_surface_tolerance	%1.1d\n",parameters.specify_surface_tolerance);
		fprintf(prterr,"parameters.surface_dist_tolerance		%6.4f\n",parameters.surface_dist_tolerance);
		fprintf(prterr,"parameters.surface_angular_tolerance	%6.4f\n\n",parameters.surface_angular_tolerance);
		
		fprintf(prterr,"parameters.specify_curve_tolerance		%1.1d\n",parameters.specify_curve_tolerance);
		fprintf(prterr,"parameters.curve_dist_tolerance			%6.4f\n",parameters.curve_dist_tolerance);
		fprintf(prterr,"parameters.curve_angular_tolerance		%6.4f\n",parameters.curve_angular_tolerance);
		fprintf(prterr,"parameters.curve_max_length				%6.4f\n\n",parameters.curve_max_length);

		fprintf(prterr,"parameters.specify_convex_facets		%d\n\n",parameters.specify_convex_facets);

		fprintf(prterr,"parameters.specify_max_facet_size		%d\n",parameters.specify_max_facet_size);
		fprintf(prterr,"parameters.max_facet_size				%6.4f\n\n",parameters.max_facet_size);

		fprintf(prterr,"parameters.number_storage_type			%d\n\n",parameters.number_storage_type);
		fprintf(prterr,"UF_FACET_TYPE_FLOAT						%d\n",UF_FACET_TYPE_FLOAT);
		fprintf(prterr,"UF_FACET_TYPE_DOUBLE					%d\n",UF_FACET_TYPE_DOUBLE);

		fprintf(prterr,"parameters.specify_parameters			%d\n\n",parameters.specify_parameters);

		fprintf(prterr,"parameters.specify_view_direction		%d\n",parameters.specify_view_direction);
		fprintf(prterr,"parameters.silh_view_direction			%6.4\n",parameters.silh_view_direction);
		fprintf(prterr,"parameters.silh_chord_tolerance			%6.4f\n\n",parameters.silh_chord_tolerance);

		fprintf(prterr,"parameters.store_face_tags				%d\n\n",parameters.store_face_tags);




	}





	goto term;
term:
	return 0;

}

/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{






  //   
	struct tm*
		newtime;
	time_t
		aclock,start_time,
		finish_time;
	double
		work_time;
	int
		min,sec;
	

	time(&start_time);// 

	//     D:
	if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
	{
		//uc1601("  <prterr.txt>    D:\\",1);
		goto label_clock;
	}

	//     C:/TEMP/
	if((prterr=fopen("C:\\TEMP\\prterr.txt","w"))!=NULL)
	{
		uc1601("  <prterr.txt>    C:\\TEMP\\",1);
		goto label_clock;
	}

	//    
	uc1601("    ",1);
	return;


label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	
	fprintf(prterr,
	"\n<create a faceted model from a solid body>		HAS STARTED		line=%d\n\n",
	__LINE__);
	
	fprintf(prterr,"   :	%s\n\n",asctime(newtime));

	errorCode=UF_initialize();PRTERR;


	//todo--------------------------------------------------------------
	*returnCode=do_it();




	errorCode=UF_terminate();PRTERR;

term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	
	fprintf(prterr,
	"<create a faceted model from a solid body>	HAS FINISHED	line=%d\n\n",
	__LINE__);
	
	fprintf(prterr,"working time is		%u	min		%u sec\n",min,sec);
	fflush(prterr);
	fclose(prterr);

	if(UF_is_initialized())
		UF_terminate();

	return;

	













}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}
